////////////////////////////////////////////////////////
//
// GEM - Graphics Environment for Multimedia
//
// zmoelnig@iem.kug.ac.at
//
// Implementation file
//
//    Copyright (c) 1997-2000 Mark Danks.
//    Copyright (c) Gnther Geiger.
//    Copyright (c) 2001-2002 IOhannes m zmoelnig. forum::fr::umlute. IEM
//    For information on usage and redistribution, and for a DISCLAIMER OF ALL
//    WARRANTIES, see the file, "GEM.LICENSE.TERMS" in this distribution.
//
/////////////////////////////////////////////////////////

#include "lbuff.h"
#include "Base/GemState.h"

CPPEXTERN_NEW_WITH_ONE_ARG(lbuff, t_floatarg, A_DEFFLOAT)

/////////////////////////////////////////////////////////
//
// lbuff
//
/////////////////////////////////////////////////////////
// Constructor
//
/////////////////////////////////////////////////////////
lbuff :: lbuff(t_floatarg size)
      : GemShape(size)
{
//    myline x;
//    x.x0 = 0;
//    x.y0 = 0;
//    x.x1 = 1;
//    x.y1 = 1;
//    lines.push_back(x);
}

/////////////////////////////////////////////////////////
// Destructor
//
/////////////////////////////////////////////////////////
lbuff :: ~lbuff()
{ }

/////////////////////////////////////////////////////////
// render
//
/////////////////////////////////////////////////////////
void lbuff :: render(GemState *state)
{

    glBegin(GL_LINES);
	    for (unsigned int n = 0; n < lines.size(); n++)
        {
            glColor4f(1,1,1,1);
            glVertex2f(lines[n].x0, lines[n].y0 );
            glVertex2f(lines[n].x1, lines[n].y1 );
        }
    glEnd();


}
/////////////////////////////////////////////////////////
// resolutionMess
//
/////////////////////////////////////////////////////////
void lbuff :: resolutionMess(int resolution)
{
    m_resolution = (resolution < 1) ? 1 : resolution;
    setModified();
}

void lbuff :: addMessCallback(void *data, t_symbol* s, int argc, t_atom*argv)
{
    
    GetMyClass(data)->addMess(argc, argv);
    
}

void lbuff :: addMess(int argc, t_atom*argv)
{
    if (argc == 4)
    {
        myline x;
        x.x0 = A_FLOAT == argv[0].a_type ? atom_getfloat(&argv[0]) : 0;
        x.y0 = A_FLOAT == argv[1].a_type ? atom_getfloat(&argv[1]) : 0;
        x.x1 = A_FLOAT == argv[2].a_type ? atom_getfloat(&argv[2]) : 0;
        x.y1 = A_FLOAT == argv[3].a_type ? atom_getfloat(&argv[3]) : 0;
        lines.push_back(x);
    }
}

// static member function
//
/////////////////////////////////////////////////////////
void lbuff :: obj_setupCallback(t_class *classPtr)
{
    class_addmethod(classPtr, (t_method)&lbuff::resolutionMessCallback,
    	    gensym("res"), A_FLOAT, A_NULL);
    class_addmethod(classPtr, (t_method)&lbuff::addMessCallback,
    	    gensym("add"), A_GIMME, A_NULL);
}
void lbuff :: resolutionMessCallback(void *data, t_floatarg res)
{
    GetMyClass(data)->resolutionMess((int)res);
}
