/*-----------------------------------------------------------------
LOG
    GEM - Graphics Environment for Multimedia

    A lbuff

    Copyright (c) 1997-1999 Mark Danks. mark@danks.org
    Copyright (c) Gnther Geiger. geiger@epy.co.at
    Copyright (c) 2001-2002 IOhannes m zmoelnig. forum::fr::umlute. IEM. zmoelnig@iem.kug.ac.at
    For information on usage and redistribution, and for a DISCLAIMER OF ALL
    WARRANTIES, see the file, "GEM.LICENSE.TERMS" in this distribution.

-----------------------------------------------------------------*/

#ifndef INCLUDE_CUBE_H_
#define INCLUDE_CUBE_H_

#include "Base/GemShape.h"
#include <string.h>
#include <vector>

struct myline
{
    float x0;
    float y0;
    float x1;
    float y1;
};

/*-----------------------------------------------------------------
-------------------------------------------------------------------
CLASS
    lbuff
    
    Creates a lbuff

KEYWORDS
    geo

DESCRIPTION
    
-----------------------------------------------------------------*/
class GEM_EXTERN lbuff : public GemShape
{
    CPPEXTERN_HEADER(lbuff, GemShape)

    public:

	    //////////
	    // Constructor
    	lbuff(t_floatarg size);
    	
    protected:
    	
    	//////////
    	// Destructor
    	virtual ~lbuff();

    	//////////
    	// Do the rendering
    	virtual void 	render(GemState *state);

        std::vector<myline> lines;

    	//////////
    	// Resolution callback
    	void	    	resolutionMess(int res);
    	
    	//////////
    	// The rendering resolution
    	int 	    	m_resolution;
    	
        //////////
    	// add callback
    	void	    	addMess(int argc, t_atom*argv);
    	
        
    private:
    	
    	//////////
    	// Static member functions
     	static void resolutionMessCallback(void *data, t_floatarg res);
        static void addMessCallback(void *data, t_symbol*, int argc, t_atom*argv);

};

#endif	// for header file
